#include <core.p4>
#define V1MODEL_VERSION 20180101
#include <v1model.p4>

header ethernet_t {
    bit<48> dst_addr;
    bit<48> src_addr;
    bit<16> eth_type;
}

struct Headers {
    ethernet_t eth_hdr;
}

struct Meta {
}

parser p(packet_in pkt, out Headers hdr, inout Meta m, inout standard_metadata_t sm) {
    state start {
        transition parse_hdrs;
    }
    state parse_hdrs {
        pkt.extract(hdr.eth_hdr);
        transition accept;
    }
}

action assign_addrs(inout Headers h, bool check_1, bool check_2) {
    h.eth_hdr.dst_addr = 4;
    if (check_1) {
        h.eth_hdr.dst_addr = 2;
        if (check_2) {
            h.eth_hdr.src_addr = 3;
        } else {
            h.eth_hdr.dst_addr = 1;
        }
    }
}
control ingress(inout Headers h, inout Meta m, inout standard_metadata_t sm) {
    apply {
        assign_addrs(h, true, true);
    }
}

control vrfy(inout Headers h, inout Meta m) {
    apply {
    }
}

control update(inout Headers h, inout Meta m) {
    apply {
    }
}

control egress(inout Headers h, inout Meta m, inout standard_metadata_t sm) {
    apply {
    }
}

control deparser(packet_out b, in Headers h) {
    apply {
        b.emit(h);
    }
}

V1Switch(p(), vrfy(), ingress(), egress(), update(), deparser()) main;

