#include <core.p4>
#define V1MODEL_VERSION 20180101
#include <v1model.p4>

struct alt_t {
    bit<1> valid;
    bit<7> port;
}

struct row_t {
    alt_t alt0;
    alt_t alt1;
}

header hdr {
    bit<32> _f0;
    bit<1>  _row_alt0_valid1;
    bit<7>  _row_alt0_port2;
    bit<1>  _row_alt1_valid3;
    bit<7>  _row_alt1_port4;
}

struct Headers {
    hdr h;
}

struct Meta {
}

parser p(packet_in b, out Headers h, inout Meta m, inout standard_metadata_t sm) {
    state start {
        b.extract<hdr>(h.h);
        transition accept;
    }
}

control vrfy(inout Headers h, inout Meta m) {
    apply {
    }
}

control update(inout Headers h, inout Meta m) {
    apply {
    }
}

control egress(inout Headers h, inout Meta m, inout standard_metadata_t sm) {
    apply {
    }
}

control deparser(packet_out b, in Headers h) {
    apply {
        b.emit<hdr>(h.h);
    }
}

control ingress(inout Headers h, inout Meta m, inout standard_metadata_t sm) {
    @name("ingress.c.tmp") hdr[1] c_tmp;
    @hidden action stackbvecbmv2l37() {
        c_tmp[0].setInvalid();
        c_tmp[0]._row_alt1_valid3 = 1w1;
        c_tmp[0]._f0 = h.h._f0 + 32w1;
        h.h._f0 = h.h._f0 + 32w1;
        h.h._row_alt1_valid3 = 1w1;
        sm.egress_spec = 9w0;
    }
    @hidden table tbl_stackbvecbmv2l37 {
        actions = {
            stackbvecbmv2l37();
        }
        const default_action = stackbvecbmv2l37();
    }
    apply {
        tbl_stackbvecbmv2l37.apply();
    }
}

V1Switch<Headers, Meta>(p(), vrfy(), ingress(), egress(), update(), deparser()) main;

